﻿using System.Collections.Generic;
using System.Windows.Input;
using WindowsInput;

namespace WpfTesting.Core.InputSimulation
{
    public static class KeyboardSimulation
    {
        private static readonly IDictionary<Key, VirtualKeyCode> KeysTransform = new Dictionary<Key, VirtualKeyCode>();

        static KeyboardSimulation()
        {
            AddLettersTransform();
        }

        private static void AddLettersTransform()
        {
            KeysTransform.Add(Key.Q, VirtualKeyCode.VK_Q);
            KeysTransform.Add(Key.W, VirtualKeyCode.VK_W);
            KeysTransform.Add(Key.E, VirtualKeyCode.VK_E);
            KeysTransform.Add(Key.R, VirtualKeyCode.VK_R);
            KeysTransform.Add(Key.T, VirtualKeyCode.VK_T);
            KeysTransform.Add(Key.Y, VirtualKeyCode.VK_Y);
            KeysTransform.Add(Key.U, VirtualKeyCode.VK_U);
            KeysTransform.Add(Key.I, VirtualKeyCode.VK_I);
            KeysTransform.Add(Key.O, VirtualKeyCode.VK_O);
            KeysTransform.Add(Key.P, VirtualKeyCode.VK_P);
            KeysTransform.Add(Key.A, VirtualKeyCode.VK_A);
            KeysTransform.Add(Key.S, VirtualKeyCode.VK_S);
            KeysTransform.Add(Key.D, VirtualKeyCode.VK_D);
            KeysTransform.Add(Key.F, VirtualKeyCode.VK_F);
            KeysTransform.Add(Key.G, VirtualKeyCode.VK_G);
            KeysTransform.Add(Key.H, VirtualKeyCode.VK_H);
            KeysTransform.Add(Key.J, VirtualKeyCode.VK_J);
            KeysTransform.Add(Key.K, VirtualKeyCode.VK_K);
            KeysTransform.Add(Key.L, VirtualKeyCode.VK_L);
            KeysTransform.Add(Key.Z, VirtualKeyCode.VK_Z);
            KeysTransform.Add(Key.X, VirtualKeyCode.VK_X);
            KeysTransform.Add(Key.C, VirtualKeyCode.VK_C);
            KeysTransform.Add(Key.V, VirtualKeyCode.VK_V);
            KeysTransform.Add(Key.B, VirtualKeyCode.VK_B);
            KeysTransform.Add(Key.N, VirtualKeyCode.VK_N);
            KeysTransform.Add(Key.M, VirtualKeyCode.VK_A);
        }

        public static void InputText(string text)
        {
            InputSimulator.SimulateTextEntry(text);
        }

        public static void KeyDown(Key key)
        {
            InputSimulator.SimulateKeyDown(KeysTransform[key]);
        }

        public static void KeyUp(Key key)
        {
            InputSimulator.SimulateKeyUp(KeysTransform[key]);
        }

        public static void KeyPress(Key key)
        {
            KeyDown(key);
            KeyUp(key);
        }
    }
}
