﻿using System.Runtime.InteropServices;

namespace WpfTesting.Core.InputSimulation
{
    public static class MouseSimulation
    {
        #region [Cursor movements]

        public static void SetCursorPosition(int x, int y)
        {
            SetCursorPos(x, y);
        }

        #endregion [/Cursor movements]


        #region [Left button]

        public static void LeftMouseClick()
        {
            LeftMouseDown();
            LeftMouseUp();
        }

        public static void LeftMouseClick(int x, int y)
        {
            SetCursorPosition(x, y);
            LeftMouseClick();
        }

        public static void LeftMouseDown()
        {
            mouse_event((uint)MouseEvent.MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
        }

        public static void LeftMouseUp()
        {
            mouse_event((uint)MouseEvent.MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
        }

        #endregion [/Left button]


        #region [WinApi]

        [DllImport("User32.Dll")]
        private static extern long SetCursorPos(int x, int y);

        [DllImport("user32.dll")]
        static extern void mouse_event(uint dwFlags, uint dx, uint dy, uint dwData, int dwExtraInfo);

        // ReSharper disable InconsistentNaming

        private enum MouseEvent
        {
            MOUSEEVENTF_ABSOLUTE = 0x8000,
            MOUSEEVENTF_LEFTDOWN = 0x0002,
            MOUSEEVENTF_LEFTUP = 0x0004,
            MOUSEEVENTF_MIDDLEDOWN = 0x0020,
            MOUSEEVENTF_MIDDLEUP = 0x0040,
            MOUSEEVENTF_MOVE = 0x0001,
            MOUSEEVENTF_RIGHTDOWN = 0x0008,
            MOUSEEVENTF_RIGHTUP = 0x0010,
            MOUSEEVENTF_WHEEL = 0x0800,
            MOUSEEVENTF_XDOWN = 0x0080,
            MOUSEEVENTF_XUP = 0x0100,
        }

        // ReSharper restore InconsistentNaming

        #endregion [/WinApi]
    }
}
