﻿using System;
using System.Runtime.InteropServices;
using Microsoft.Win32;

namespace WpfTesting.Core
{
    public static class WindowsAPI
    {

        #region [Dialogs]

        internal static bool CloseMessage(string caption)
        {
            return EndDialog(FindWindow(caption), IntPtr.Zero);
        }

        internal static bool CloseOpenFileDialog(OpenFileDialog dialog, bool fileSelected)
        {
            if (String.IsNullOrEmpty(dialog.Title))
                throw new ArgumentException("Can't use empty title for dialog");
            
            return EndDialog(FindWindow("Открыть"), new IntPtr(fileSelected ? 1 : 0));
        }

        internal static bool IsWindowExists(string caption)
        {
            return !FindWindow(caption).Equals(IntPtr.Zero);
        }

        #endregion [/Dialogs]


        #region [Private methods]

        private static IntPtr FindWindow(string caption)
        {
            return FindWindowEx(IntPtr.Zero, IntPtr.Zero, null, caption);
        }

        #endregion [/Private methods]


        #region [WinApi]

        [DllImport("user32.dll")]
        private static extern IntPtr FindWindowEx(IntPtr parentHandle, IntPtr childAfter, string lclassName, string windowTitle);

        [DllImport("user32.dll")]
        private static extern bool EndDialog(IntPtr window, IntPtr result);

        #endregion [/WinApi]

    }
}
