﻿using System.Windows;
using WpfTesting.Core.InputSimulation;

namespace WpfTesting.HighLevel
{
    public static class Common
    {
        internal static void Click(FrameworkElement element)
        {
            Point coordinates = GetAbsoluteCenterCoordinates(element);
            MouseSimulation.LeftMouseClick((int)coordinates.X, (int)coordinates.Y);
        }

        internal static Point GetAbsoluteCoordinates(FrameworkElement element)
        {
            return element.PointToScreen(new Point(0, 0));
        }

        internal static Point GetAbsoluteCenterCoordinates(FrameworkElement element)
        {
            Point coordinates = GetAbsoluteCoordinates(element);
            return new Point(coordinates.X + (element.ActualWidth / 2), coordinates.Y + (element.ActualHeight / 2));
        }
    }
}
